unit FontTest;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs;

type

  { TText1 }

  TText1 = class(TPersistent)
   private
     FOwner : TCustomControl;
     FFont  : TFont;
     procedure SetFont(AValue: TFont);


   protected

   public
     constructor create(aOwner:TCustomControl);

   published
     property Font: TFont read FFont write SetFont;

end;

  type

  { TText2 }

  TText2 = class(TPersistent)
   private
     FOwner : TCustomControl;
     FFont  : TFont;
     procedure SetFont(AValue: TFont);


   protected

   public
     constructor create(aOwner:TCustomControl);

   published
     property Font: TFont read FFont write SetFont;

end;



type

  { TFontTest }

  TFontTest = class(TCustomControl)
  private
    fdir: string;
    fFont: TFont;
    FTextStyle: TTextStyle;
    FText1: TText1;
    FText2: TText2;
    procedure SetAlignment(AValue: TAlignment);
    procedure setdir(AValue: string);
    procedure SetFont(AValue: TFont);
    procedure FontPropertyChanged(Sender:TObject);
    procedure T1FontPropertyChanged(Sender:TObject);
    procedure SetLayout(AValue: TTextLayout);
    procedure SetText2(AValue: TText2);
    procedure SetTextStyle(AValue: TTextStyle);
    procedure SetText1(AValue: TText1);
  protected

  public
   constructor Create(AOwner: TComponent); override;
   destructor  Destroy; override;
   procedure   Paint; override;
   property TextStyle: TTextStyle read FTextStyle write SetTextStyle;
  published
   property Font: TFont read fFont write SetFont;
   property CaptionAlignment:TAlignment read FTextStyle.Alignment write SetAlignment default taCenter;
   property CaptionLayout:TTextLayout read FTextStyle.Layout write SetLayout default tlCenter;

   property Text1 : TText1 read FText1 write SetText1;
   property Text2 : TText2 read FText2 write SetText2;

   property Dir : string read fdir write setdir;
  end;

procedure Register;

implementation

procedure Register;
begin
  {$I fonttest_icon.lrs}
  RegisterComponents('Standard',[TFontTest]);
end;
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
{ TText2 }

procedure TText2.SetFont(AValue: TFont);
begin
 if FFont=AValue then Exit;
  //FFont:=AValue;
  FFont.Assign(aValue);
end;

constructor TText2.create(aOwner: TCustomControl);
begin
 FOwner:=aOwner;
 inherited create;
 if Assigned(FOwner) then FOwner.Invalidate;
end;

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
{ TText_1 }

procedure TText1.SetFont(AValue: TFont);
begin
  if FFont=AValue then Exit;
  //FFont:=AValue;
  FFont.Assign(aValue);
end;

constructor TText1.create(aOwner: TCustomControl);
begin
 FOwner:=aOwner;
 inherited create;
 if Assigned(FOwner) then FOwner.Invalidate;
end;


//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
{ TFontTest }

constructor TFontTest.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);


  FText1       := TText1.create(self);
  FText1.FFont  := TFont.Create;
  FText1.FFont.OnChange:=@T1FontPropertyChanged;

  FText2       := TText2.create(self);
  FText2.FFont  := TFont.Create;

  width := 200;
  height:= 400;

  fFont := TFont.Create;
  ffont.OnChange:= @FontPropertyChanged;

  FTextStyle.Alignment := taCenter;
  FTextStyle.Layout    := tlCenter;
  FTextStyle.SingleLine:= false;

end;

destructor TFontTest.Destroy;
begin
  inherited Destroy;
  ffont.Free;
  FText1.FFont.Free;
  FText1.Free;
  FText2.FFont.Free;
  FText2.Free;
end;

procedure TFontTest.SetFont(AValue: TFont);
begin
  if fFont=AValue then Exit;
  fFont.Assign(aValue);            //nicht := !!!
  canvas.Font.Assign(aValue);
  //showmessage('SetFont');
  Invalidate;
end;

procedure TFontTest.FontPropertyChanged(Sender: TObject);
begin
 canvas.Font.Assign(FFont);
 Invalidate;
end;

procedure TFontTest.T1FontPropertyChanged(Sender: TObject);
begin
  invalidate;
end;

procedure TFontTest.SetTextStyle(AValue: TTextStyle);
begin
  //if FTextStyle=AValue then Exit;  muss auskommentiert werden!
  FTextStyle:=AValue;

end;

procedure TFontTest.SetText1(AValue: TText1);
begin
  if FText1=AValue then Exit;
  FText1:=AValue;
  Invalidate;
end;

procedure TFontTest.SetLayout(AValue: TTextLayout);
begin
 if fTextStyle.Layout=AValue then exit;
  fTextStyle.Layout:=AValue;
  Invalidate;
end;

procedure TFontTest.SetText2(AValue: TText2);
begin
  if FText2=AValue then Exit;
  FText2:=AValue;
  Invalidate;
end;

procedure TFontTest.SetAlignment(AValue: TAlignment);
begin
 if fTextStyle.Alignment=AValue then exit;
  fTextStyle.Alignment:=AValue;
  Invalidate;
end;

procedure TFontTest.setdir(AValue: string);
begin
  //if fdir=AValue then Exit;
  fdir:=getcurrentdir;
end;



procedure TFontTest.Paint;
var R : TRect;
begin
  inherited Paint;
  canvas.Brush.Color:= clSilver;
  canvas.FillRect(0,0,width,height);

  canvas.Font.Assign(self.FFont);
  R := rect(10,10,160,40);
  canvas.Rectangle(R);
  canvas.TextRect(R,0,0,'self.Font',fTextStyle);

  canvas.Font.Assign(FText1.FFont);
  R := rect(10,50,160,80);
  canvas.Rectangle(R);
  canvas.TextRect(R,0,0,'Text1.Font',fTextStyle);

  canvas.Font.Assign(FText2.FFont);
  R := rect(10,90,160,120);
  canvas.Rectangle(R);
  canvas.TextRect(R,0,0,'Text2.Font',fTextStyle);
end;

end.
